/* :ts=8
 *
 *	writeclock()
 *
 * writes the values contain in the buf structure into the battery
 * backed clock.
 *
 */

#include "setdate.h"
extern	struct tm buf;

writeclock()
{
	int	i;	/* temp var for loop control */

		/* take clock out of test mode */
	outportb(0x70, 0x00);
		/* stop clock */
	outportb(0x7e, 0x00);

		/* seconds and hundreths of seconds */
		/* these are read-only ports in the real time clock which */
		/* are set to zero when the clock is stopped.  I set the */
		/* values to zero to indicate what the clock was really set */
		/* to, regardless of what is in the buf structure. */
	buf.tm_hsec = 0;
	buf.tm_sec = 0;

		/* minute */
	outportb(0x74, buf.tm_min % 10);
	outportb(0x75, buf.tm_min / 10);

		/* hour */
	outportb(0x76, buf.tm_hour % 10);
	outportb(0x77, buf.tm_hour / 10);

		/* day */
	outportb(0x78, buf.tm_mday % 10);
	outportb(0x79, buf.tm_mday / 10);

		/* day of week */
		/* stored in program as 0-6; in real time clock as 1-7 */
	outportb(0x7a, buf.tm_wday + 1);

		/* month */
		/* stored in program as 0-11; in real time clock as 1-12 */
	outportb(0x7b, buf.tm_mon + 1 % 10);
	outportb(0x7c, buf.tm_mon + 1 / 10);

		/* year */
		/* stored in program as year from 1900; in real time */
		/* clock as an offset from a leap year */
	outportb(0x7d, 0x08 >> (buf.tm_year - LEAP_YEAR & 0x03));

		/* initialize interupts */
	outportb(0x7f, buf.tm_year - LEAP_YEAR | 0x08);
	for (i = 0; i < 3; ++i)
		inportb(0x7f);

		/* start clock */
	outportb(0x7e, 0xff);
}
